#include <stdio.h>
#include <stdlib.h>
const char *version="2016-05-13";
/* 
   using  BLAS = Basic Linear Algebra Subroutines 
   !!! --- used by ./configure --- !!!
 ToDo2016: check best liwork+check-numa/cpupinning on t100
   while X=$(pgrep a.out);do ps -m -o pid,sid,psr,pcpu,time,cmd -p $X;sleep 30;done 
 ToDo2016: add float32 (cheevd+ssyevd) for configure --float16 ??? -DVecType=4
 ToDo: wie weit kommt man auf quanta1/2 mit 768GB? + Schaetzung Rechenzeit
       24er Kette cplx, nev=0
 DSYEV - all eigenvalues [+eigenvectors] of a real symmetric matrix A
         'V' n1 <= 46300 (16.0GB) n1^2-int32-overflow blas-interface
*        'N' n1 <= 125000++(116GB=free)
 ZHEEV - all eigenvalues [+eigenvectors] of a complex Hermitian matrix A
         'V' n1 <= 32767 (16.1GB) n1^2-int32-overflow blas-interface
*        'N' n1 <= 46000++ (32.2GB) segfault @16GB
 DSYEVD - faster thread-parallel speed (divide and conquer), -d
*        'V' n1 <= 32766 (24.1GB) malloc *work failed ToDo!!!
         'N' n1 <= 125000++(116GB=free)
 ZHEEVD - faster thread-parallel speed (divide and conquer), -d
*        'V' n1 <= 32767 (40.0GB,56GB?)  malloc *rwork failed ToDo!!!
         'N' n1 <= 46000++ (32.2GB) segfault @16GB
  compile:
   Tru64: cc -migrate lapack_test.c -ldxml # single_thread_only
   IRIX:  cc lapack_test.c -lscs[_i8][_mp] # [integer8][multi-processor]
   SuSE8: cc -DF2C lapack_test.c -llapack -lf2c  # lapack-3.0 + blas-3.0
   SuSE8: cc -DF2C lapack_test.c -llapack -lf2c -lblas -lm -static # nonshared
   SuSE10: lapack-3.0-926=/usr/lib/liblapack.so.3.0.0 32bit
   ScL6.5: cc -llapack lapack_test.c             # quanta2 2013
   ScL6.5: cc -lopenblas -lpthread lapack_test.c # quanta2 2015
           OMP_NUM_THREADS=1 ./a.out 1000   # + valgrind test
 ACML = AMD Core Math Library (closed source) http://developer.amd.com
   acml-5-3-1-gfortran-64bit.tgz 70MB loki, dead since 2013, single thread
   see clBLAS + clSparse (OpenCL)
 BLAS from netlib
  or ATLAS automatic arcitecture-adapted BLAS
 LAPACK Univ.Tennessee+California+Colorado_Denver+NAG_Ltd
   SMP/MT improved EISPACK+LINPACK libs (Mem-access-pattern) using BLAS
 OpenBLAS
  debian: apt-get install libopenblas-base
  http://github.com/xianyi/OpenBLAS/archive/v0.2.9.tar.gz # 0.2.18=slow?
  default: threads (Makefile.rule: USE_OPENMP=1 for openmp-use, k2.6.32-bug)
  make TARGET=xxx CC=gcc492 FC=gfortran492 # see TargetList.txt
    Makefile.rule: PREFIX = /opt/openblas/0.2.14 +WARMUP +AFFINITY
    OpenBLAS build complete. (BLAS CBLAS LAPACK LAPACKE)
    Library Name     ... libopenblas_barcelonap-r0.2.18.a (Multi threaded; Max num-threads is 16)
    Makefile.rule: LAPACKE (C Interface to LAPACK), OMP
    Affinity/warmup disabled!?
  make install PREFIX=/opt/openblas/0.2.18 # ToDo: why 0.2.18 4x slower?
               COMMON_OPT="-O2"
  # 0.2.18 fails on gcc412 or gcc492@comp2.node, set CC+FC=gfortran=ok (~g77)
  # 0.2.18 comp2: make CC=gcc44 FC=gfortran44 = OK (bit slower)
  # 0.2.18 comp2: .rule -O3 + gcc492
  # 0.2.15 loki: gcc411 compile fail,  L144 driver/others/memory.c
  #        edit: #define CONSTRUCTOR __attribute__ ((constructor))
  # 0.2.9 comp2: faster!
  
  OPENBLAS_NUM_THREADS=4 ./a.out 8000 # 4cpus zeitweise
  OPENBLAS_VERBOSE=1  # warning at runtime
  OPENBLAS_CORETYPE=Haswell  # strings: .14=HASWELL .15=Haswell+*_HASWELL
  OPENBLAS_NUM_THREADS  # in t100.0.2.14 only!!! .2.15 single-task only?
  OMP_NUM_THREADS       # in t100.0.2.14 only!!! n1=4000 nur 5s parallel
  OMP_WAIT_POLICY="PASSIVE" ???
  GOMP_CPU_AFFINITY="0-15:1"  # only if compiled as openmp?
  OMP_PROC_BIND=TRUE|FALSE|{MASTER,CLOSE|SPREAD}  # omp_proc_bind_t omp_get_proc_bind(void);
  export KMP_AFFINITY=verbose,scatter # intel only
  export KMP_VERSION=.TRUE.
  allow huge pages! cores*8pages
    If you want to allocate 64 large pages (8 cores),
    $shell> echo  0 > /proc/sys/vm/nr_hugepages         # need to be reset
    $shell> echo 65 > /proc/sys/vm/nr_hugepages         # add 1 extra page
    $shell> echo 3355443200 > /proc/sys/kernel/shmmax   # just large number
    $shell> echo 3355443200 > /proc/sys/kernel/shmall
    Also may add lines into /etc/security/limits.conf file + sshd restart
    *       hard    memlock          unlimited
    *       soft    memlock          unlimited
 --
 ScaLAPACK PSSYEVX /PDSYEVX  sample??? ToDo2016 S=Single D=Double
           PCHEEVX /PZHEEVX  C=cplx Z=cplx-dbl
 wf: 16*Alpha-EV67-21264A-731MHz (64KBI+64KBD-OnChipCache) 4MB-ext.cache Nov00
  # wf.alpha  n1 dsyev zheev runtime in seconds 
   wf       1000    24    81 s dsyev im cache?
   wf       1500   133   262 s
   wf       2000   283   702 s
   wf       2500   627  1285 s
   wf       3000  1038  2375 s
   wf       3500  1764  3466 s
   time[s] = 4e-8 * n1^3 (wf: GS160-alpha-731MHz dsyev) size=a*n1^2
   time[s] = 8e-8 * n1^3 (wf: GS160-alpha-731MHz zheev) size=a*n1^2
 2016-04-26 1*2*2loki-Opt275-2.2GHz-1024kB+sse2+3dnow 16GB CentOS-5 2005-07
   # grep zheevd /usr/lib64/lib* # acml lapack(3.0.3)
   # strings /usr/lib64/libacml*.a # GCC 3.3 2003 /opt/acml2.6.0 acmlinfo 2005
   CentOS5: gcc lapack_test.c -lacml /usr/lib64/libg2c.so.0
   CentOS5: gcc lapack_test.c -lacml -lg2c # after: ln -s X.so.0 X.so
   CentOS5: gcc lapack_test.c /opt/acml2.6.0/gnu64/lib/libacml.a -lg2c
   CentOS5: gcc lapack_test.c /opt/acml5.3.1/gfortran64/lib/libacml.a # -FAIL- no OMP_NUM_THREADS
   CentOS5+gcc4.1.1: gcc lapack_test.c -lopenblas # *_opteronp-r0.2.15.so 14m
   # OpenBLAS-0.2.15: compile fail,  L144 driver/others/memory.c
   #   correction: #define CONSTRUCTOR __attribute__ ((constructor))
   #   ln -s /opt/openblas-0.2.15/lib/libopenblas_opteronp-r0.2.15.so /usr/lib64/libopenblas.so
   #   ln -s /opt/openblas-0.2.15/lib/libopenblas.so.0 /usr/lib64/libopenblas.so.0
   run: time numactl --physcpubind=1 ./a.out 2000 # rtime+0..20% else
   # nt  n1 dsyev +V dsyevd+V zheev +V zheevd+V # loki lapack3.0.3 m=minutes
     1 1000 0.026 -    0.113  0.061 -    0.211 m loki lapack3.0.3 lwork+=32*n1
     1 2000 0.224 -    0.889  0.501 -    1.785 m loki lapack3.0.3 lwork+=32*n1
   # nt  n1 dsyev +V dsyevd+V zheev +V zheevd+V # loki acml+g2c s=seconds
     1 1000 0.018 .073 0.036  0.047 -    0.108 m loki acml lwork+=32*n1 numa
     1 2000 0.135 .572 0.270  0.364 -    0.833 m loki acml lwork+=32*n1 numa
   # nt  n1 dsyev +V dsyevd+V zheev +V zheevd+V unit # loki openblas_opteronp-r0.2.15 2016-05
     4 4000 0.473 6.245 0.808 0.960   -   1.791 m loki openblas lwork+=32*n1 numactl
     4 8000 2.693  49.6 4.903 7.156   -   12.94 m loki openblas lwork+=32*n1 numa
     -old- no_affinity?
   # openblas-r0.2.15 +Make.rule -NO_WARMUP -NO_AFFINITY c0,2,1,3=c0,2,+1
   #    numactl --physcpubind bei use of affinity ohne Wirkung!
   # nt  n1 dsyev dsyevd +V zheev zheevd +V unit # loki openblas_opteronp-r0.2.15+warmup+affinity 2016-05
     1 2000 0.090 0.091 0.215 0.264 0.264 0.616 m loki openblas lwork+=32n1
     1 4000 0.688 0.689 1.631 2.098 2.098 4.816 m loki openblas lwork+=32n1 nu c0
     2 4000 0.430 0.430 0.994 1.170 1.170 2.671 m loki openblas lwork+=32n1 c0,2(+aff) (ignores numactl)
     4 4000 0.315 0.315 0.664 0.713 0.713 1.530 m loki openblas lwork+=32n1 numa
     # for comparision comp2-opt-2.3GHz:  0.801 m 2x faster (barcelona, memory ch)
     4 8000 2.208 2.207 4.709 5.292 5.263 11.53 m loki openblas lwork+=32n1 c0,2,+1
     # ToDo: compile .a using gcc4.9?
 2016-05-10 N455-1GHz lapack.so.3gf (for comparision)
    # nt b1 dsyev dsyevd +V   zheev zheevd +V
     1 1000 0.091 0.090 0.209 0.330 0.334 0.659 m lapack3 lwork+=32*n1
     1 2000 0.664 0.663 1.506 2.250 ...
 2016-04-15 12*6mkautz-MIPS-500MHz 4GB libatlas? 2009 --- <mkautz> ---
  # cat /proc/sys/vm/nr_hugepages # not available k2.6.18
  #  grep zheev: liblapack + libscalapack
  # better document with LIB? (LIB="-lopenblas" gcc -O2 lapack_test.c $LIB)
   gcc    lapack_test.c -llapack -lblas  # single-thread
   gcc    lapack_test.c -llapack -lgotoblas -lpathfortran # WARNalloc
   mpicc  lapack_test.c -lscalapack ??? ToDo
   pathcc lapack_test.c -llapack -lblas
   pathcc lapack_test.c -llapack -lgotoblas          -lpathfortran # WARNalloc
   pathcc lapack_test.c -llapack -lgotoblas_pthreads -lpathfortran # Walloc/thread
   # GotoBLAS Warning ... Bigphysarea alloation was failed. +50%hang+Ediff
   # libopenblas_mips64p-r0.2.14.a 22MB (2016-05 make so failed)
   pathcc lapack_test.c libopenblas_mips64p-r0.2.14.a -lpthread -lgfortran
   pathcc -static lapack_test.c libopenblas_mips64p-r0.2.14.a -lpthread -lgfortran -lm
   # GotoBLAS Warning ... Bigphysarea alloation was failed. - fixed in SC-4.0
   # nt  n1  dsyev dsyevd+V time_unit
     1  1000  .195 .263 m lapack blas  dsyev=0.195m=12s (single thread)
     1  1000  .110 .223 m lapack gotoblas          pf # Walloc+Wdiff 
     6  1000  .092 .139 m lapack gotoblas_pthreads pf # Walloc+Wdiff+50%hanging
     1  1000  .139 .261 m openblas_mips64p-r0.2.14.a
     6  1000  .044 .107 m openblas_mips64p-r0.2.14.a lwork+=0
     6  1000  .044 .107 m openblas_mips64p-r0.2.14.a lwork+=32*n1
   --
   # nt   n1  dsyev   +V dsyevd    +V  zheev   +V zheevd +V unit gcc412.openblas_mips64p-0.2.14 in m=minutes
     1  2000  1.132 10.9   1.76  1.92   2.79 20.0 4.16 10.41 m openblas_mips64p-0.2.14 2016-04
     6  2000  0.291  9.9   0.60  0.67  0.65  17.0 1.22  3.36 m openblas_mips64p-0.2.14 2016-04
     6  2000  0.286  9.87  0.590 0.649 0.650 17.0 1.246 2.99 m memalign4K
     1  2000  1.100 10.91  1.100 1.878 2.770 20.0 2.777 4.85 m lwork+=32*n1
     2  2000  0.648 10.31  0.648 1.153 1.563 18.3 1.563 2.74 m lwork+=32*n1
     4  2000  0.385  9.96  0.384 0.756 0.878 17.3 0.878 1.65 m lwork+=32*n1
     6  2000  0.287  9.87  0.286 0.650 0.638 17.0 0.638 1.32 m lwork+=32*n1
   --  # a9[99] __attribute__ ((aligned (64))) ?
   --  # one array per page? = minimum array size?
    #   int posix_memalign(void **memptr, size_t alignment, size_t size);
    # _POSIX_C_SOURCE >= 200112L
   # nt   n1  dsyev   +V dsyevd    +V  zheev   +V zheevd +V gcc412.openblas_mips64p-0.2.14 in minutes
     1  4000  10.02 92.7  10.03 15.68  23.51 156  23.50 39.49 m lwork+=32*n1
     1  4000  10.00 92.6  17.00 15.8   23.48 156  37.90 86.6  minutes openblas_mips64p-0.2.14 2016-04
     2  4000   5.72 87.5  11.45  9.3   12.68 141  24.09 61.5  m openblas_mips64p-0.2.14 2016-04
     4  4000   3.20 84.4   6.93  5.7    6.90 133  14.14 37.7  m openblas_mips64p-0.2.14 2016-04
     6  4000   2.29 83.4   4.87  4.7    4.91 131   9.88 26.1  m openblas_mips64p-0.2.14 2016-04
     6  4000   2.26 83.5   2.27  4.59   4.90 131   4.86  9.68 m lwork+=32*n1
     #                        *d+V=faster?(nonoptimal worksize!?)
   # nt   n1  dsyev   +V dsyevd    +V  zheev   +V zheevd +V gcc412.openblas_mips64p-0.2.14 in minutes
     6  8000   18.0 (11h?) 39.8  35.6   38.5 (13h?) 79.2 -OOM- m openblas_mips64p-0.2.14 2016-04
     # zheevd +V (3*0.95GB) = SIGNAL-11 = OOM? (after mmap34MB+134MB ret=-1)
     -- ToDo: plot speed per clock, 4core-speedup per arch
     </mkautz>
 2016-04-14 16c-comp2 AMD-Opteron6134-2.3GHz lapack3.0.3,openblas[op]-r0.2.8
   cat /proc/sys/vm/nr_hugepages # 0  2016-04--
   comp2-CentOS5: cc -lopenblasp lapack-test.c 
   comp2.n04: gcc -O2 utils/lapack_test.c /usr/lib64/libopenblas.so.0
   nt  1  n1  4000 128MB 
   TARGET= OPTERON_SSE3 BARCELONA SHANGHAI ISTANBUL ??? Magny-Cours?
   OpenBLAS-0.2.18=SLOW: make CC=gcc492 FC=gfortran492 # TARGET=barcelona CC=gcc=FAIL! 
   gcc lapack_test.c -lopenblasp   # 0.2.8p +gfortran +pthread
   gcc lapack_test.c /opt/openblas/0.2.9/lib/libopenblas_barcelonap-r0.2.9.a -lgfortran -lpthread
   gcc lapack_test.c /opt/openblas/0.2.14/lib/libopenblas_barcelonap-r0.2.14.a -lgfortran -lpthread
   gcc lapack_test.c /opt/openblas/0.2.18/lib/libopenblas_barcelonap-r0.2.18.so
   gcc lapack_test.c /cluster/goto/libgoto2_barcelonap-r1.13.so -lgfortran
   gcc lapack_test.c /usr/lib64/liblapack.so.3.0.3
   gcc lapack_test.c /opt/openblas/0.2.14/lib/libopenblas_barcelonap-r0.2.14.a -lm -lpthread -lgfortran
   gcc lapack_test.c -static -L/opt/openblas/0.2.14/lib -lopenblas_barcelonap-r0.2.14 -lpthread -lgfortran -lm
   gcc lapack_test.c -fopenmp /opt/openblas/0.2.14/lib/libopenblas_omp_barcelonap-r0.2.14.a -lm -lpthread -lgfortran
     # haengt on node!  ToDo2016! get omp running!
   # gcc492 -fopenmp -O2 ../utils/lapack_test.c -L/opt/openblas/0.2.14/lib -lopenblas_omp_barcelonap-r0.2.14 -lpthread -static -lgfortran -L/opt/gcc-4.9.2/lib64 -lm
   # module load openblas/0.2.8  # /opt/openblas/0.2.8/
   LD_LIBRARY_PATH=/opt/openblas/0.2.18/lib\:/opt/gcc-4.9.2/lib64 OMP_NUM_THREADS=1 time ./a.out 4000
   # dsyevd 2000 lwork+=6000 better,   +32000 best speedup=2 !!! 2016-05
   # dsyevd 4000 lwork+=12000 better, +110000 best 0.082m (0.150m dflt)
   # dsyevd 8000 lwork+=24000 better, +256000 best 0.674m (1.353m dflt)
   #  core-abhaengig? no (hier 16 cores) cpu-type?
   ## ToDo: plot speed_blas/n1^3 vs. log(n1) + scaling_speed vs. cpus (some n1)
   --  system -lopenblasp # r0.2.8  E0(2000)= -3519.219620 or -192.042273
   # nt n1    dsyev  +V dsyevd +V zheev   +V zheevd +V openblas-r0.2.8p(+affinity)
     1  2000 .047  .535 .047 .111  .135 1.05 .135 .308 m lwork+=32*n1 ~numa
     2  2000 .028  .535 .028 .072  .079  -   .079 .188 m lwork+=32*n1 ~numa c0,4
     4  2000 .016  .601 .016 .045  .044  -   .044 .108 m lwork+=32*n1 ~numa c0,4,8,12
     8  2000 .011  .590 .011 .032  .027 1.14 .027 .068 m lwork+=32*n1 ~numa c0,4,8,12,4*+1
    16  2000 .010  .593 .010 .028  .020  -   .020 .050 m lwork+=32*n1 ~numa c0,4,12,8,4*+1,+2,+3
   # zheevd+V= 0.050 (16 runs),  memalign4k has no effect
   #  min_zheevdV ab  lwork += 60060(+1.5%) = 0.050 min (0.125/2.5)
   #  max_zheevdV bei lwork +=  2002(+.05%) = 0.598 min (0.125*4.8)        
   # nt n1   dsyev   +V dsyevd +V zheev   +V zheevd +V openblas-r0.2.14p
     1  2000 .047  .488 .047 .112 .136 1.559 .136 .308 m lwork+=32*n1 +numactl c0
    16  2000 .014  .434 .013 .034 .041 1.386 .042 .075 m lwork+=32*n1 ~numa c9,11,0,5,... bad order pinned!
   ToDo2016 compile + Affinity!
   --
  # nt  n1   dsyev dsyevd+V zheev zheevd+V minutes LIB comp2
     1  4000  -     4.1     -     -  m system -lopenblas = openblas-r0.2.8p
     1  4000  -    18       -     -  m openblas_barcelonap-r0.2.18 SLOW !!???
     1  4000  -     4.1     -     -  m goto2_barcelonap-r1.13 OMP_NUM_THREADS=1
     1  4000  -     5.9     -     -  m lapack-3.0.3
     1  4000 0.354  0.826  1.065 2.374 m openblas_barcelonap-r0.2.9 no_affinity lwork+=32*n1
     1  4000 0.356  0.822  1.065 2.370 m openblas_barcelonap-r0.2.14 +affinity+warmup lwork+=32*n1 c0,4,12,8,+1,+2,+3
    16  4000 0.218  0.331  0.487 0.691 m openblas_barcelonap-r0.2.9 no_affinity lwork+=32*n1
    16  4000 0.082  0.177  0.196 0.361 m openblas_barcelonap-r0.2.14 +affinity+warmup lwork+=32*n1 c0,4,12,8,+1,+2,+3
    16  4000 0.082  0.176  0.195 0.361 m openblas-r0.2.8p lwork+=32*n1 ~numa
   --                    
   # nt n1   dsyev   +V dsyevd +V  zheev   +V zheevd   +V openblas-r0.2.8p
     1  4000  .362 4.09  .730  .838 1.063 8.12 1.66 4.580 minutes dflt
     1  4000  .358 4.13  .356  .825 1.061 8.16 1.06 2.365 m lwork+=32*n1 ~numa
     2  4000  .228  -    .228  .536  .611  -   .611 1.396 m lwork+=32*n1 ~numa c0,4
     4  4000  .141  -    .141  .325  .358  -   .360 0.803 m lwork+=32*n1 ~numa c0,4,12,8
     8  4000  .099  -    .099  .219  .234  -   .234 0.489 m lwork+=32*n1 ~numa c0,4,12,8,4*+1
    16  4000  .082 4.59  .082  .176  .195 8.79 .194  .361 m lwork+=32*n1 ~numa c0,4,12,8,+1,+2,+3
    16  4000  .092 4.53  .16   .19   .207 8.69 .367 1.18  m dflt lwork
    #                                               ^^^^  3.3x to_slow
     8  4000  .132 4.03  .251  .260  .290 8.02 .524 1.78  m dflt n3.reboot +numa
   -- try workspace bigger than cache!?
   # nt n1   dsyev   +V dsyevd +V  zheev   +V zheevd   +V openblas-r0.2.8p
     1  8000  2.81 32.69 5.93 6.39 8.70 63.3  13.63 37.24 minutes +numactl
    16  8000  .70  35.79 1.38 1.27 1.52 67.60  2.76  9.09 m lwork=opt(?)+0
    #                    ^^^^                 ^^^^^ ^^^^^ to_slow!
     1  8000  2.75 32.11 2.75 6.30 8.56 63.04  8.59 18.77 m lwork+=32*n1 ~numa
     2  8000  1.70 33.42 1.70 3.96 4.81 65.07  4.83 10.69 m lwork+=32*n1 ~numa 
     8  8000  .761   -   .759 1.53 1.742  -    1.742 3.55 m lwork+=32*n1 ~numa(or numa --localalloc --physcpubind=0,2,4,6,8,10,12,14)
    16  8000  .674   -   .674 1.23 1.44   -    1.44  2.52 m lwork+=32*n1 +aln4K +numa
    # cat /proc/sys/vm/nr_hugepages # 0 2016-05-- set to 65 6.5.16 =same_speed
    # numactl --localalloc --physcpubind=0-7 ..., better compile +affinity!
    ps -eLF| grep a.out # 5*1thread/core+1*2threads/core wechselnd! ~affinity!
   # nt n1   dsyev +V dsyevd +V  zheev +V zheevd +V openblas-r0.2.8p
     1 16384 65.59  - - 106.26 89.130  -  - 179.867 m r0.2.14+a+w lwork+=32n1 c0,4,12,8,+1,+2,+3
     8 16384 9.069  - - 18.562 17.293  -  -  33.829 m r0.2.14+a+w lwork+=32n1 c0,4,12,8,+1,+2,+3
*   16 16384 6.412  - - 13.200 12.955  -  -  23.882 m r0.2.14+a+w lwork+=32n1 c0,4,12,8,+1,+2,+3
     1 16384 -      - 66 -     ca9.2h -  ca5.3h - system -lopenblasp # r0.2.8
     #       -      - 6.0GB -  4.0GB  - 14GB    -
   --
   # nt n1   dsyev +V dsyevd +V  zheev +V zheevd +V openblas-r0.2.8p
    16 32768  50.95    -  -OVL- 121.15  -   -   -OVL- m lwork+=32n1 r0.2.8 c0,4,12,8,+1,+2,+3 dsyev=2.8GB t=t8000*8.59
    16 32768 ca.51min
    #         8GB      -    -    16GB   -  40GB?  -
   -- 
   max_n1(real,nev=0)=124000 (115GB zero fill with single thread = ca.2min)
                starts (@2min) + computes single until 3.3m, than 160%, @4m ^C
   max_n1(zheev,nev=0,16t)=46000 (32.2GB + SHR=5.8GB(BLAS-MPT)) OK
   max_n1(zheev,nev=0,16t)=47000 (33.6GB, zero fill until 15GB than segfault)
   max_n1(zheev,nev=0,16t)=88000 (116GB, zero fill until 15GB than segfault)
   max_n1(zheev,nev=0,16t)=89000 malloc failt
   max_n1(zheevd,nev=0,16t)=46000 (32.2GB + SHR4.3GB++) OK 
   max_n1(zheevd,nev=0,16t)=47000 (33.6GB, zero fill until 15GB than segfault)
   --- end-comp2 ---
 2014-03-10 quanta2=E5-4620-2.2GHz(++?) atlas-sse3/openblas? scalapack-PDSYEVD/PZHEEVD
   # /opt/OpenBlas/include/openblas_config.h 0.2.8 64bit AVX 2013-10-01
   # /opt/OpenBlas/lib64/libopenblas_sandybridgep-r0.2.8.so = linked /lib/lib64
   # gcc -O2 lapack_test.c -g -lopenblas # autolinked: +math+pthread+gfortran
   # GOMP_CPU_AFFINITY="0-31:1" ??? ohne Wirkung?
   # OMP_NUM_THREADS=1 time numactl --physcpubind=0 ./a.out 32000 # -OK-
   # dsyevN dsyevV dsyevdN dsyevdV
   #  evl. bad performance durch stopped 650GB-background process
   -- openblas_sandybridgep-r0.2.14 q1.(~core0) E0= -3519.219620
   n1  1  n1  2000 dsyevN  3.6s V 46.4s dN  6.3s dV  9.1s q1.c0=1.2GHz --defect--
   n1  1  n1  2000 dsyevN  1.3s V 17.2s dN  2.4s dV  3.4s q1.c1-31 2.2GHz++
   n1  2  n1  2000 dsyevN  0.9s V 15.9s dN  1.3s dV  2.4s c1-4
   n1  4  n1  2000 dsyevN  0.7s V 16.2s dN  0.8s dV  1.8s c1-4
   -- openblas_sandybridgep-r0.2.14 q1.(~core0) E0= -3651.847174
   n1  1  n1  4000 dsyevN 10.6s V    -  dN 23.3s dV 24.9s c1-31 .42GB
   n1  2  n1  4000 dsyevN  6.6s V    -  dN 14.0s dV 23.0s c1-31 only_pinned
   n1  4  n1  4000 dsyevN  4.9s V    -  dN  7.7s dV 11.0s c1-31
   n1  8  n1  4000 dsyevN  4.8s V  218s dN  5.6s dV  9.5s c1-31
   n1 16  n1  4000 dsyevN  5.6s V  128s dN  8.6s dV 13.5s c1-31 8.6-10.8s
   --
   nt  1  n1  4000 244MiB 11.3m zheev
   -- openblas_sandybridgep-r0.2.14 q1.(~core0) E0= -3697.834127
   n1  1  n1  8000 dsyevN  -    V  -    dN  -    dV -     c1-31
   n1  2  n1  8000 dsyevN  155s V  -    dN  -    dV -     c1-31
   n1  4  n1  8000 dsyevN 64.2s V  -    dN  -    dV -     c1-31
   n1  8  n1  8000 dsyevN 76.0s V  -    dN  197s dV -     c1-31
   n1 16  n1  8000 dsyevN 71.6s V  -    dN  148s dV -     c1-31
   n1 32  n1  8000 dsyevN 62.5s V  -    dN  168s dV -     c1-31
   -- openblas_sandybridgep-r0.2.14 q1.(~core0) E0= -3697.834127
   n1  1  n1 16384 dsyevN  -    V  -    dN  -    dV -     c1-31
   n1  2  n1 16384 dsyevN  -    V  -    dN  -    dV -     c1-31
   n1  4  n1 16384 dsyevN  -    V  -    dN  -    dV -     c1-31
   n1  8  n1 16384 dsyevN  -    V  -    dN  -    dV -     c1-31
   n1 16  n1 16384 dsyevN  -    V  -    dN  -    dV -     c1-31
   n1 32  n1 16384 dsyevN  -    V  -    dN  -    dV -     c1-31
   --
   n1  1  n1 16384 6.2GB  54.1m dsyevd openblas_sandybridgep-r0.2.14 ~pinned
   nt  1  n1 16384 4.1GB  596m=9.9h (x52=3.75^3) zheev
   nt 32  n1 16384 4.1GB   19m (speedup=21 for 32 cores OK) zheev
   n1  1  n1 32768 8.3GB   ?    dsyev  openblas_sandybridgep-r0.2.14
   n1  1  n1 32000  23GB  ca7h  dsyevd openblas_sandybridgep-r0.2.14 ~pinned
   n1  1  n1 32768  fail  ca7h  dsyevd openblas_sandybridgep-r0.2.14
   nt 32  n1 78416 spack 1060m=17.7h nzx-dependend?
   nt 30  n1 91504        22h   dsyev nev=0 richter2015
   ## quanta1: libopenblas_sandybridgep-r0.2.14.so 2015-04-21 !!!   
   ## ToDo: 
 2016-04-13 t100.c502.dsyev: libopenblas = libopenblas_haswellp-r0.2.14
   # t100b: module load openblas/gcc/64/0.2.14; cc -lm -lpthread -lopenblas ...
   # srun -I60 -N1 -n1 -t0:20:00 bash -c \
   #   "module load gcc/4.8.2;module load openblas/gcc/64/0.2.14;\
   #   OMP_NUM_THREADS=4 ./a.out 4000"
   # gcc  lapack_test.c /cluster/apps/openblas/gcc/0.2.14/lib/libopenblas_haswellp-r0.2.14.a  -lm -lgfortran -lpthread
   # gcc  lapack_test.c /cluster/apps/openblas/gcc/0.2.14/lib/libopenblas_haswellp-r0.2.14.so -lm -lgfortran -lpthread
   # /cluster/apps/openblas/gcc/0.2.15/lib/libopenblas-r0.2.15.a single! 17.12.15 CV
   # /cluster/apps/openblas/gcc/0.2.15/lib/libopenblas_haswellp-r0.2.15.a 17.05.16 JS +AFFINITY
   # nt n1  dsyev dsyevd+V zheev zheevd+V # openblas/gcc/64/0.2.14
    1  4000 .139  .252     -     -    m node.haswell-2.4GHz++ lwork+=32n1
    2  4000 .071  .163     -     -    m node.haswell-2.4GHz++ lwork+=32n1
    4  4000 .044  .101     -     -    m node.haswell-2.4GHz++ lwork+=32n1 c9,1,10,2 2.14.a
    8  4000 .034  .081     -     -    m node.haswell-2.4GHz++ lwork+=32n1 c2,9,3,10 2.14.a
   16  4000 .031  .117     -     -    m node.haswell-2.4GHz++ openblasp-r0.2.14 lwork+=32n1 c1,9,12,0,...(wechselnd) 0.2.14.a.2015-12
   16  4000 .027  .067     .063  .130 m node.haswell-2.4GHz++ openblasp-r0.2.14+aff+warmup lwork+=32n1 c0,8,+1,+2,... 0.2.14.a.2016-05
   16  4000 .025  .065     .063  .130 m node.haswell-2.4GHz++ openblasp-r0.2.15+aff+warmup c0,8,+1,+2,...
   *         32768  malloc *work failed
   # c502.haswell-2.4GHz++: cat /proc/sys/vm/nr_hugepages # 0 2016-05--
   # nt n1   dsyev   +V dsyevd  +V zheev   +V  zheevd   +V openblas-r0.2.14p
     1  8000 1.109   -   1.116 2.030 3.286  -    -    5.544 m lwork+=32n1 0.2.14p.2016-05+aff+warmup
     1  8000 1.129   -   1.137   -    -     -    -      -   m lwork+=32n1 0.2.14p.2015-12
     1  8000 1.14  12.07 2.729 2.075 3.262 38.8 6.542 16.62 minutes (clk-boost)
     2  8000 0.613 11.43 1.415 1.222 1.767 36.8 3.465  8.94 m =2.4..3.1*comp2-speed
     4  8000 0.361 11.00 0.805 0.691 0.954 35.4 1.855  4.89 m
     8  8000 0.259 10.96 0.577 0.546 0.582 34.0 1.117  3.32 m
    16  8000 0.223 11.02 0.474 0.818 0.443 34.5 0.984  3.24 m dsyev=.223-.231m
    16  8000 0.222 11.00 0.217 0.814 0.445 34.5 0.457 1.903 m lwork+=32n1 dsyev=.222-.234m 0.2.14p.2015-12
    16  8000 0.222   -    -    0.453 0.443  -    -    0.867 m lwork+=32n1 c0,8,+1,+2,... 0.2.14p.2016-05+aff+warmup
   # nt n1   dsyev   +V dsyevd  +V zheev   +V  zheevd   +V openblas-r0.2.15p
     8  8000 0.235 -     -     0.531 0.561  -    -    1.051 m lwork+=32n1 openblasp-r0.2.15 c0,8,+1,+2,+3
    16  8000 0.216 -     -     0.450 0.442  -    -    0.874 m lwork+=32n1 openblasp-r0.2.15 c0,8,+1,+2,...
    # +/-numactl ? + mon psr
   # nt n1   dsyev   +V dsyevd  +V  zheev   +V zheevd   +V openblas-r0.2.14p
     1 16384 11.17   -   -    20.43 28.64   -   -   48.80 m lwork+=32n1 0.2.14p+aff+warmup.2016-05 c2
     2 16384 6.051   -   -    11.77 15.26   -   -   28.23 m lwork+=32n1 0.2.14p+aff+warmup.2016-05 c0,8
     4 16384 3.215   -   -    6.701 8.045   -   -   15.08 m lwork+=32n1 0.2.14p+aff+warmup.2016-05 c0,8,+1
     8 16384 2.021   -   -    4.621 4.577   -   -   8.701 m lwork+=32n1 0.2.14p+aff+warmup.2016-05 c0,8,+1,+2,+3
    16 16385 1.762   -   -    3.455 3.428   -   -   6.683 m lwork+=32n1 0.2.14p+aff+warmup.2016-05 c0,8,+1,+2,...
     2 16384 5.923   -  6.015 12.00 15.31   - 15.27 25.86 m lwork+=32n1 no_affinity,no_warmup
     4 16384 3.214   -  3.215 6.327 8.008   - 7.939 14.10 m lwork+=32n1 no_affinity,no_warmup
     8 16384 2.101 110  2.044 4.449 4.683   - 4.698  8.30 m lwork+=32n1 no_affinity,no_warmup
    16 16384 1.728 113  1.714 6.534 3.543 332 3.559 15.66 m lwork+=32n1 no_affinity,no_warmup
    #                         ^^^^^                 ^^^^^ to slow!?
    16 16384 1.702  -    -    3.425  -      -  -      -   m lwork+=32*n1 openblasp-r0.2.15 c0,8,+1,+2,...
    # ToDo: vergleich speed-up gegen aeltere Rechner mit BJ (comp2,meggie,10*kautz)
    #
     1 32768 95.26   -      - -OVL-     -   -     - -OVL- bad DSTEDC parameter number  8
    # threads not pinned! compile pinning version
 ToDo2016: check best liwork+check-numa/cpupinning on t100
   while X=$(pgrep a.out);do ps -m -o pid,sid,psr,pcpu,time,cmd -p $X;sleep 30;done 
  --- end-of-performance-sample--data ---
  history:
   2016-05-10 add lwork-offset lworka
   2016-04-28 replace macro NEV by nev set by option -V
              replace CFG_DSYEVD by aaa=1 set by option -d
 */
 
/* PMMAAA=dsyev_   see https://en.wikipedia.org/wiki/LAPACK
 * P:      d=double=64bit,s=single=32bit,c=cplx=2x32bit,z=cplxd=2x64bit 
 *  MM:    sy=symmetric, he=cplx_hermitian, ge=unsymNxN
 *    AAA: ev_=simple evx=expert evd=divide-and-conquere(size+N**2) evr=MRRR
 * examples: ssyevd, dsyevd, cheevd, zheevd    (LAPACK(BLAS))
 *          pdsyevd,                pzheevd (ScaLAPACK(PBLAS(BLAS+BLACS(MPI,PVM))))
 *          p=parallel(mpi)?
 * ToDo: https://wiki.gwdg.de/index.php/ScaLAPACK
 * ToDo: http://www.netlib.org/blacs/ 
 * ToDo: http://www.netlib.org/scalapack/pblas_qref.html
 * ToDo: openblas.get_num_nodes goto_get_num_procs blas_num_threads ?
 *       openblas_get_config gotoblas_corename support_avx?
 */

/* 2016-05-03 */
#ifdef _OPENMP
#include <omp.h>
#endif

#include <sys/time.h>  /* 2016-05-09 added */
double fstime(){       /* 2016-05-09 added */
 struct timeval tv; if (gettimeofday(&tv, NULL)) perror("fstime");
 return tv.tv_sec+1e-6*tv.tv_usec; }
  
/* LAPACK/BLAS declarations ToDo: use include? */
#ifdef __cplusplus
extern "C" /* avoid special (C++)-names in object files, ex: main__Fv */
#endif
void dsyev_( /* reel symmetric eigenvalues + optional(slow) eigenvectors */ 
        const char *jobz,   /* (in) "N"=NoVectors, "V"=Vectors */
        const char *uplo,   /* (in) "U"=UpperTriangleA, "L"=LowerTA */
        const int *n,       /* (in) order of matrix */
        double *a,          /* a[n][lda] (in/out) */
        const int *lda,     /* (inp) leading dimension >=max(1,n) */
        double *w,          /* w[n] (out) eigenvalues */
        double *work,       /* work[lwork] (workspace/out) */
        const int *lwork,   /* (in)   >= max(1,3*n-1) better (nb+2)*n */
        int *info);         /* (out) ==0 on success */
#ifdef __cplusplus
extern "C" /* avoid special (C++)-names in object files, ex: main__Fv */
#endif
void dsyevd_( /* divide&conquer: eigenvalues slower, but fast eigenvectors */
        const char *jobz,   /* (in) "N"=NoVectors, "V"=Vectors */
        const char *uplo,   /* (in) "U"=UpperTriangleA, "L"=LowerTA */
        const int *n,       /* (in) order of matrix */
        double *a,          /* a[n][lda] (in/out) */
        const int *lda,     /* (inp) leading dimension >=max(1,n) */
        double *w,          /* w[n] (out) eigenvalues */
        double *work,       /* work[lwork] (workspace/out) */
        const int *lwork,   /* (in)    */
                            /* lwork = 1+6n+2n^2 for V, 2n+1 for N */
                            /* ToDo: less memory, bigger matrizes, NEV=0 */
                            /* ToDo: int = 32bit limit ! n1<=1<<15=32768 */
        int *iwork,         /* array[liwork], [1] returns optimal LIWORK */
        const int *liwork,  /* size = 3+5n */
        int *info);         /* (out) ==0 on success */
/* /opt/openblas/0.2.18/include/lapacke.h: ... */
#ifdef __cplusplus
extern "C" /* avoid special (C++)-names in object files, ex: main__Fv */
#endif
void zheev_( /* complex hermitian */
        const char *jobz,   /* (in) "N"=NoVectors, "V"=Vectors */
        const char *uplo,   /* (in) "U"=UpperTriangleA, "L"=LowerTA */
        const int *n,       /* (in) order of matrix */
        double *a,          /* a[n][lda][2] (in/out), diagonal part I=0 */
        const int *lda,     /* (inp) leading dimension >=max(1,n) */
        double *w,          /* w[n] (out) eigenvalues */
        double *work,       /* work[lwork][2] (workspace/out) */
        const int *lwork,   /* (in)   >= max(1,2*n-1) better (nb+2) */
        double *rwork,      /* rwork[max(1,3N-2)] workspace 0..? 1..? */
        int *info);         /* (out) ==0 on success */
        /* nb = blocksize for ZHETRD returned by ILAENV = 32 */
#ifdef __cplusplus
extern "C" /* avoid special (C++)-names in object files, ex: main__Fv */
#endif
void zheevd_(
        const char *jobz,   /* (in) "N"=NoVectors, "V"=Vectors */
        const char *uplo,   /* (in) "U"=UpperTriangleA, "L"=LowerTA */
        const int *n,       /* (in) order of matrix */
        double *a,          /* a[n][lda][2] (in/out), diagonal part I=0 */
        const int *lda,     /* (inp) leading dimension >=max(1,n) */
        double *w,          /* w[n] (out) eigenvalues */
        double *work,       /* work[lwork][2] (workspace/out) */
        const int *lwork,   /* (in)   >= max(1,2*n-1) better (nb+2) */
        double *rwork,      /* rwork[max(1,3N-2)] workspace 0..? 1..? */
                            /* lwork = 2n+n^2 for V, n+1 for N */
        int *lrwork,        /* rwork-dim V: 1+5n+2n^2  n1<=2^15=32768 */
        int *iwork,         /* array[liwork], [1] returns optimal LIWORK */
        const int *liwork,  /* size = 3+5n */
        int *info);         /* (out) ==0 on success */
/* ZHEEV-calls:
 * - ZLANHE + ZLASCL: scale to allowable range
 * - ZHETRD: reduce Hermitian matrix to tridiagonal form
 *    blocked + unblocked (ZLATRD + ZHERK2 + ZHETD2=(ZLARFG,ZHEMV,ZDOTC,Z
 * - DSTERF: eigenvalues OR ZUGTR=unitary_matrix + ZSTEQR eigenvects
 * - DSCAL: scale back
 */
static const double myfabs(const double x){ return ((x>=0) ? x : -x ); }
                                               
int main(int argn, char *argv[]){
  size_t i0;
  int n1=2, lda, lwork=0, info=-1, i, j, i3, /* n1 = matrix size per option */
      cf=1,       /* complex_size_factor: dbl=1, cplx=2 */
      nev=0,      /* 1=eigenvalues+vectors, 0=eigenvalues_only 2016-04-28 */
      debug=0, cplx=0, /* 1=DBL*8 C, 0=CPLX*16(emulated by dbl[n*2]) */
      aaa=0,  /* algo_aaa: 0=dsyev/zheev 1=dsyevd/zheevd */
      nb=32;  /* optimum block size, have seen 32 or 60 but dt=2% */
  char jobz='N'; /* default excluding vector (faster+bigger matrizes) */
  double *a, *w, *work, t0, t1, t2, dw=0.0;
  int lrwork=-1;  /* added 2016-04-13 for rwork, unused for DSYEV/ZHEEV */
  double *rwork=NULL;
  int liwork=-1;   /* aaa=1: array[liwork], [1] returns optimal LIWORK */
  int *iwork=NULL; /* aaa=1: [3+5*n] */
  int lworka=0;   /* 2016-05-11 optional more workspace for performance ? */
  setvbuf(stdout, (char *)NULL, _IONBF, 0); /* no buffer */
  for (i=1;i<argn;i++){  /* scan options */
    if (argv[i][0]=='-' && argv[i][1]=='V' && argv[i][2]=='\0') nev=1; else
    if (argv[i][0]=='-' && argv[i][1]=='Z' && argv[i][2]=='\0') cplx=1; else
    if (argv[i][0]=='-' && argv[i][1]=='d' && argv[i][2]=='\0') aaa=1; else
    if (argv[i][0]=='-' && argv[i][1]=='D' && argv[i][2]=='\0') debug=1; else
    if (argv[i][0]=='-' && argv[i][1]=='a') lworka=atoi(argv[i]+2); else
    if (argv[i][0]>='0' &&  argv[i][0]<='9') n1=atoi(argv[i]); else
    { printf("ERROR: unknown option\nuse: %s [-V] [-Z] [-d] [-D] [-aNNN]\n"
             "   V=+eigenvectors Z=cplx d=method_XXXevd D=debug\n",
             argv[0]);
      break; }
  }
  if (nev) jobz='V';
  cf= 1+cplx;      /* complex_size_factor: dbl=1, cplx=2 */
  lda=n1;          /* matrix dimension */
  if (nb<3) { printf(" nb must be 3 or greater\n");exit(1);}
  if (cplx==0) {
    lwork=(nb+2)*n1;   /* dsyev-optimum = (32+2)*n1, 2016-04-13 */
    if (aaa==1) lwork= (nev) ? 1+6*n1+2*n1*n1 : nb+2*n1; /* dsyevd 2016-04 */
  } else { /* CPLX  */
    lwork=(nb+1)*n1;   /* zheev-optimum = (32+1)*n1 working space */
    lrwork= 3*n1-2;  /* added 2016-04-13 for rwork, unused for DSYEV/ZHEEV */
    /* check for n1*n1 overflow! (set additional size_t llwork?) */
    if (aaa==1) lwork= (nev) ? 0+2*n1+n1*n1 : 1+n1; /* optimum 2016-04-26 */
    if (aaa==1) lrwork=(nev) ? 1+5*n1+2*n1*n1 : n1; /* optimum 2016-04-26 */
  } /* CPLX */
#ifdef _OPENMP
  { int omp_n=1; /* omp_set_num_threads(2); */
#pragma omp parallel
    omp_n= omp_get_num_threads();  /* must be called within parallel pragma */
    /* next line is outside parallel region */
    printf(" OpenMP threads=%d\n", omp_n); /* no mpi */
  }
#endif
  if (lworka<0) lworka=32*n1; /* best speed found? 2016-05 */
  lwork += lworka;
  t0=fstime(); /* starttime */
  printf(" n1=    %12d  matrix[GiB]= %8.2f    version=%s\n",
           n1, n1*1.*n1*cf*sizeof(double)/(1<<30), version);
  if (lwork) printf(" lwork_add= %8d\n", lworka);
  printf(" lwork= %12d    work[GiB]= %8.2f\n",
           lwork, cf*1.*lwork*sizeof(double)/(1<<30)); /* fix cf 2016-04-27 */
  /* int-overflow check added 2014-03 */
  if (  (lwork*1L*cf)*sizeof(double)
      !=(lwork*(size_t)cf)*sizeof(double)){printf("ERROR: work overflow\n");}
  if (  ((nb+1)        *n1*cf)*sizeof(double)
      !=((nb+1)*(size_t)n1*cf)*sizeof(double)){printf("ERROR: lwork overflow\n");}
  if (  (size_t)(cf   *n1*n1) /* avoid c++ sign_vs_unsigned-compare warning */
      !=(size_t)(cf*(size_t)n1*n1)){printf("ERROR: n1^2 int overflow\n");}
  if (  (cf   *n1*n1*sizeof(double))
      !=(cf*(size_t)n1*n1*sizeof(double))){printf("ERROR: n1^2 cplx overflow\n");}
  /* allocating necessary memory malloc(size_t) */
  a=    (double *)malloc(cf*(size_t)n1*n1*sizeof(double)); /* 2016-04-27 add 1L */
  w=    (double *)malloc(      (size_t)n1*sizeof(double));
  work= (double *)malloc(cf*(size_t)lwork*sizeof(double));
  if ((!work)||(!a)||(!w)) { printf(" malloc *work failed\n");exit(1); }
  if (debug) /* bad speed */
    for(i0=0;i0<(size_t)(cf*lwork);i0++) work[i0]=170.6640625; /* special pattern 0xAA.AA */
  if (aaa==1) { /* 2016-04-25 added d&c-algo */
    liwork= (nev) ? 3+5*n1 : 1;  /* zheevd, dsyevd */
    printf(" liwork= %11d   iwork[GiB]= %8.2f\n",
             liwork, liwork*1.*sizeof(int)/(1<<30));
    iwork= (int *)malloc(liwork*sizeof(int));
    if (!iwork) { printf(" malloc *iwork failed\n");exit(1); }
  }
  /* now generating a pseudo-random matrix for test and diagonalize it */
  /* rand() is slow !*/
  { int r1;srand(1); r1=rand(); /* c86_64.CentOS5 2016-05 checked */
    if (r1!=0x6b8b4567) printf("WARNING unexpected 1st random: %08x", r1);}
  srand(1);
  if (cplx==0) { /* real random matrix */
    /* for(i=0;i<n1;i++)for(j=0;j<=i;j++) a[i*n1+j]=a[j*n1+i]=0.0; old=bad!? */
    for(i=0;i<n1;i++)for(j=0;j<n1;j++) a[i*(size_t)n1+j]=0.0;
    for(i=0;i<n1;i++)for(j=0;j<64;j++) { /* 16 NZ per line, comp2: 26s 16..160 */
      i3=(rand()%n1); 
      a[i*(size_t)n1+i3]=a[i3*(size_t)n1+i]=(i3&255)-2.5;
    }
  }
  if (cplx) {  /* generate random complex matrix */
    for(i=0;i<n1;i++)for(j=0;j<2*n1;j++) a[i*n1+j]= 0.0;
    for(i=0;i<n1;i++)for(j=0;j<64;j++){  /* 64 NZ per line */
      i3=(rand()%n1);
      a[(i*(size_t)n1+i3)*2  ]= (a[(i3*(size_t)n1+i)*2  ]=(i3&7)-4); /* real */
      a[(i*(size_t)n1+i3)*2+1]=-(a[(i3*(size_t)n1+i)*2+1]=(i3&2)-1); /* imag */
    }
    printf(" lrwork= %11d   rwork[GiB]= %8.2f\n",
             lrwork,       lrwork*1.*sizeof(double)/(1<<30));
    rwork= (double *)malloc(lrwork*1L*sizeof(double));
    if (!rwork) { printf(" malloc *rwork failed ...\n"); /* exit(1); */
      lrwork= ~(1<<31); /* max int  */
      printf(" lrwork= %11d   rwork[GiB]= %8.2f\n",
               lrwork,      lrwork*1.*sizeof(double)/(1<<30));
      rwork= (double *)malloc(lrwork*1L*sizeof(double));
      if (!rwork) { printf(" malloc *rwork failed\n"); exit(1); }
    }
    if (debug) /* bad speed */
      for(i=0;i< lrwork;i++)rwork[i]=170.6640625; /* special pattern 0xAA.AA */
  } /* cplx */
  t1= fstime(); /* starttime LAPACK */
  if (cplx==0 && aaa==1) { /* 2016-04-25 added d&c-algo */
    int lwork2=-1; /* output int array!? */
    int liwork2=-1; /* output int array!? */
    dsyevd_(&jobz,"U",&n1,a,&lda,w,work,&lwork2,iwork,&liwork2,&info);
    printf(" optimal workspace  work= %11.0f <= %10d\n", work[0], lwork);
    printf(" optimal workspace iwork= %11d <= %10d\n", iwork[0], liwork);
    printf(" LAPACK dsyevd %c",jobz);
    dsyevd_(&jobz,"U",&n1,a,&lda,w,work,&lwork,iwork,&liwork,&info);
  }
  if (cplx==0 && aaa==0) { /* ~CFG_DSYEVD, here older slower dsyev */
    int lwork2=-1; /* output int array!? */
    dsyev_(&jobz,"U",&n1,a,&lda,w,work,&lwork2,&info);
    printf(" optimal workspace work= %11.0f <= %10d\n", work[0], lwork);
    printf(" LAPACK dsyev  %c",jobz);
    dsyev_(&jobz,"U",&n1,a,&lda,w,work,&lwork,&info);
  }
  if (cplx && aaa==1) /* 2016-04-25 added d&c-algo fast */
  { int lwork2=-1,lrwork2=-1,liwork2=-1; /* output int via cplx array! */
    zheevd_(&jobz,"U",&n1,a,&lda,w,work,&lwork2,rwork,&lrwork2,iwork,&liwork2,&info);
    printf(" optimal workspace size  work= %11.0f <= %10d\n",work[0],lwork);
    printf(" optimal workspace size rwork= %11.0f <= %10d\n",rwork[0],lrwork);
    printf(" optimal workspace size iwork= %11d <= %10d\n",iwork[0],liwork);
    printf(" LAPACK zheevd %c",jobz);
    /* openblas-0.2.14 allocs mem, which may cause signal 11 on OOM (mkautz) */
    zheevd_(&jobz,"U",&n1,a,&lda,w,work,&lwork,rwork,&lrwork,iwork,&liwork,&info);
    if (debug) {/* bad speed */
      for(j=i=0;i<lrwork;i++) if(rwork[i]!=170.6640625)j=i; /* pattern 0xAA.AA */
      printf(" debug: last modified rwork index = %11d\n", j); /* fix 2016-04-26 */
    }
  }
  if (cplx && aaa==0) { int lwork2=-1; /* output int via cplx array!? YES! result=(32+1)*n1 */
    zheev_(&jobz,"U",&n1,a,&lda,w,work,&lwork2,rwork,&info); /* no lrwork */
    printf(" optimal workspace size  work= %11.0f <= %10d\n",work[0], lwork);
    printf(" LAPACK zheev  %c",jobz);
    zheev_(&jobz,"U",&n1,a,&lda,w,work,&lwork,rwork,&info);
  }
  t2= fstime(); /* endtime lapack */
  printf(" info=%d time,incl_ini[m]= %10.3f  %10.3f\n",
           info, (t2-t1)/60., (t2-t0)/60.);
  if (debug) { /* bad speed, add check trace! */
    for(j=i0=0;i0<(size_t)lwork;i0++) if(work[i0]!=170.6640625)j=(int)i0; /* pattern 0xAA.AA */
    printf(" debug: last modified  work index = %11d\n", j);
  }
  printf(" w=");
  for(i=0;i<n1;i++) {
    if (i<16 || i>=n1-8) printf(" %f",w[i]); else
    if (i==16) printf(" ...");
  }
  /* results: 2016-05-09 comp2+openblasp-0.2.8 */
  if (n1==2     && (!cplx)) dw= w[0]+4.549510; /* mkautz: 3377.672754; */
  if (n1==1000  && (!cplx)) dw= w[0]+3377.674826; /* mkautz: 3377.672754; */
  if (n1==2000  && (!cplx)) dw= w[0]+3519.219620;
  if (n1==4000  && (!cplx)) dw= w[0]+3651.847174;
  if (n1==8000  && (!cplx)) dw= w[0]+3697.834127;
  if (n1==16384 && (!cplx)) dw= w[0]+3751.608701;
  if (n1==32768 && (!cplx)) dw= w[0]+3763.212169;
  if (n1==2     &&  (cplx)) dw= w[0]+7.653312;
  if (n1==1000  &&  (cplx)) dw= w[0]+186.321537;
  if (n1==2000  &&  (cplx)) dw= w[0]+192.042273;
  if (n1==4000  &&  (cplx)) dw= w[0]+196.067614;
  if (myfabs(dw)>=1e-6) printf(" WARNING: w[0] differs by %10.7f\n", dw);
#ifdef EV    /* lot of output, only if you want it, ToDo: for octave? */
  for(i=0;i<n1 && i<4;i++){
    printf("\n v%06d=",i);
    for(j=0;j<n1;j++){
      if (cplx==0) printf(" % f",a[i*n1+j);
      if (cplx) printf(" (% f, % f)",a[(i*n1+j)*2],a[(i*n1+j)*2+1]);
    }
  }
#endif
  printf("\n"); return 0;
}

#ifdef F2C
/* lapack needs f2c and f2c needs MAIN__() */
/* if you know a better solution, please tell me (libf2c or libg2c?) */
#ifdef __cplusplus
extern "C" /* avoid special (C++)-names in object files, ex: MAIN____Fv */
#endif
int MAIN__(int argn,char *argv[]){ return main(argn,argv); }
#endif
